;========================================================================
;                                                                       =
;                          Stoichiometry-86 v2.4                        =
;                                                                       =
; BASIC Version Written By:  Jay Maus       cloaker@hotmail.com         =
;   ASM Version Written By:  Morgan Davies  morgan@ticalc.org           =
;                                           Morgazum85@Juno.com         =
;                                                                       =
;              Upload Date:  March 10, 2004                             =
;                 ASM Size:  969 Bytes                                  =
;               Basic Size:  1493 Bytes                                 =
;                                                                       =
; Information about the source:                                         =
;                                                                       =
;   This program is a direct port from the 86 Basic Version. The sole   =
; purpose of this code was to simulate the function and all the options =
; available in the Basic version while keeping the appearance of a Basic=
; file. I utilized Menu86, a routine that draws the menus that you see  =
; in the program and Lite86 II which compressed the program and took off=
; 524 bytes. If anyone has questions about 86 assembly math please feel =
; free to contact me (Morgan) at either of the above e-mail addresses.  =
;                                                                       =
; Special Thanks:                                                       =
;                                                                       =
;   Kirk Meyer   (kirkmeyer@bigfoot.com)                                =
;    For making Lite 86 II, and therefor making 86 ASM programs smaller =
;   Jay Maus     (cloaker@hotmail.com)                                  =
;    For writing the original program which I used to make this from.   =
;                                                                       =
;========================================================================


#include "ti86asm.inc"
#include "Asm86.h"
#include "Rom86.h"

.plugin lite86;                     ;the ultimate compression routine, saved 524 bytes

_ioprompt   =$c324
_asap_ind   =$d623
_getcode    =$4068

.org _asm_exec_ram 

    nop                             ;no operation so...
    jp Start                        ;relative jump to Start
    .dw 0                           ;type of input
    .dw STR0                        ;print string

Start:
    call _flushallmenus             ;clears all key codes
    call _runindicoff               ;turn off run indicator
    call _clrScrn                   ;clears screen
    call _homeup
    ld hl,STR1                      ;loads hl with string
    call _puts                      ;print string
Menu1:
    call EmptyMenu
    ld hl,STR2                      ;string to print
    ld bc,256*58+3                  ;column 107, row 59
    ld (_penCol),bc                 ;loads c into _penCol
    call _vputs                     ;print it and return
    call MenuRoutine2               ;goes to MenuRoutine2
GetKey1:
    call _getcode
    cp K_ALPHA
    jp z,CalcOff
    cp K_EXIT
    jp z,Exit
    cp K_MORE
    jp z,Menu2
    cp K_F1
    jp z,Equ1
    cp K_F2
    jp z,Equ2
    cp K_F3
    jp z,Equ3
    cp K_F4
    jp z,Equ4
    cp K_F5
    jp z,Equ5
    jr GetKey1

Menu2:
    call EmptyMenu
    ld hl,STR3                      ;string to print
    ld bc,256*58+6                  ;column 107, row 59
    ld (_penCol),bc                 ;loads c into _penCol
    call _vputs                     ;print it and return
    call MenuRoutine1               ;goes to MenuRoutine1
GetKey2:
    call _getcode
    cp K_ALPHA
    jp z,CalcOff
    cp K_EXIT
    jp z,Exit
    cp K_MORE
    jp z,Menu1
    cp K_F1
    jp z,Equ6
    cp K_F2
    jp z,Exit
    jr GetKey2

Equ1:
    call Text4                      ;goes to Text4
    ld hl,G1
    call _puts
    ld hl,A1
    call Input
    call _op1toop4
    ld hl,G2
    call _puts
    ld hl,A2
    call Input
    call _FPRECIP
    call _op4toop2
    rst 28h
    call _stoY
    call _newline
    ld hl,A3
    jr SubEqu2

Equ2:
    call Text4                      ;goes to Text4
    ld hl,B1
    call _puts
    ld hl,A1
    call Input
    call _stoY
    ld hl,G2
    call _puts
    ld hl,A2
    call Input
    rst 08h
    call _rclY
    rst 28h
    call _newline
    ld hl,B3
SubEqu2:
    call _puts                      ;prints string
    ld hl,(256*2)+4                 ;loads hl with coordinates
    ld (_curRow),hl                 ;loads _curRow with hl
    call DispAnswer                 ;goes to DispAnswer
    ld a,25
    call _setXXop2
    ld hl,Na                        ;load hl with Pie3
    call _mov10toop1                ;move 10 bytes @ hl to OP1
    call _YTOX
    rst 08h
    call _rclY
    rst 28h
    ld hl,A4
    call _puts                      ;prints string
    ld hl,(256*2)+6                 ;loads hl with coordinates
    ld (_curRow),hl                 ;loads _curRow with hl
    call DispAnswer                 ;goes to DispAnswer
    jp Menu1                        ;jumps to Text7

Equ3:
    call Text4                      ;goes to Text4
    ld hl,G1
    call _puts
    ld hl,A1
    call Input
    rst 08h
    ld hl,G2
    call _puts
    ld hl,A2
    call Input
    call _ex_op1_op2
    call _FPDIV
    rst 08h
    ld hl,C1
    call _puts
    ld hl,A2
    call Input
    rst 28h
    rst 08h
    ld hl,G3
    call _puts
    ld hl,C2
    call Input
    call _op1toop6
    rst 28h
    call _stoX
    call _newline
    ld hl,B3
    call _puts
    call _newline
    call _newline
    call _newline
    call _newline
    ld hl,(256*2)+4                 ;loads hl with coordinates
    ld (_curRow),hl                 ;loads _curRow with hl
    call DispAnswer
    call _op6toop2
    call _rclX
    call _FPDIV
    call _op1toop4
    ld a,25
    call _setXXop2
    ld hl,Na                        ;load hl with Pie3
    call _mov10toop1                ;move 10 bytes @ hl to OP1
    call _YTOX
    call _op4toop2
    rst 28h
    ld hl,A4
    call _puts
    ld hl,(256*2)+6                 ;loads hl with coordinates
    ld (_curRow),hl                 ;loads _curRow with hl
    call DispAnswer
    jp Menu1                        ;jumps to Text7

Equ4:
    call Text4                      ;goes to Text4
    ld hl,G4
    call _puts
    ld hl,D1
    call Input
    rst 08h
    ld hl,C1
    call _puts
    ld hl,D1
    call Input
    rst 28h
    call _newline
    ld hl,D2
    call _puts
    call _newline
    call _newline
    call _newline
    call _newline
    ld hl,(256*2)+4                 ;loads hl with coordinates
    
    ld (_curRow),hl                 ;loads _curRow with hl
    call DispAnswer
    call Text1
    rst 28h
    ld hl,A4
    call _puts
    ld hl,(256*2)+6                 ;loads hl with coordinates
    ld (_curRow),hl                 ;loads _curRow with hl
    call DispAnswer
    jp Menu1                        ;jumps to Text7

Equ5:
    call Text4                      ;goes to Text4
    ld hl,G1
    call _puts
    ld hl,A1
    call Input
    rst 08h
    ld hl,G5
    call _puts
    ld hl,D1
    call Input
    call _ex_op1_op2
    call _FPDIV
    rst 08h
    ld hl,E2
    call _puts
    ld hl,D1
    call Input
    rst 28h
    call Text1
    rst 28h
    call _stoX
    call _newline
    ld hl,D2
    call _puts
    call _newline
    call _newline
    call _newline
    call _newline
    ld hl,(256*2)+4                 ;loads hl with coordinates
    ld (_curRow),hl                 ;loads _curRow with hl
    call DispAnswer
    call Text1
    rst 28h
    ld hl,A4
    call _puts
    ld hl,(256*2)+6                 ;loads hl with coordinates
    ld (_curRow),hl                 ;loads _curRow with hl
    call DispAnswer
    jp Menu1                        ;jumps to Text7

Equ6:
    call Text4                      ;goes to Text4
    ld hl,G4
    call _puts
    ld hl,D1
    call Input
    call Text1
    call _FPDIV
    rst 08h
    ld hl,F1
    call _puts
    ld hl,G6
    call Input
    rst 28h
    rst 08h
    ld hl,F2
    call _puts
    ld hl,E1
    call Input
    rst 28h
    call _newline
    ld hl,B3
    call _puts
    call _newline
    call _newline
    ld hl,(256*2)+6                 ;loads hl with coordinates
    ld (_curRow),hl                 ;loads _curRow with hl
    call DispAnswer
    jp Menu1                        ;jumps to Text7

Text1:
    call _stoY
    ld a,4
    call _setXXop1
    ld a,10
    call _setXXop2
    call _FPDIV
    ld a,22
    call _setXXop2
    rst 30h
    rst 08h
    call _rclY
    ret

Text4:
    call _clrScrn                   ;clear screen
    call _homeup                    ;move to upper left
    ret                             ;return

Input:
    ld de,_ioprompt                 ;$c324 - string storage for display when prompte
    call _mov10b                    ;$427b - move 10 bytes from hl to de
    ld a,$0d                        ;type of input
                                    ;$0d - # value
                                    ;$0c - string
    ld (_asap_ind),a                ;$d623 - tell ti86 what kind to be inputted
    jp _exec_pg3                    ;$5714 - ti86 os input
                                    ;the number inputted is always stored to OP1
    ret                             ;return

DispAnswer:
    ld a,48                         ;loads a with 48
    call _formReal                  ;forms answer to real #
    ld hl,_OP3                      ;loads answer into hl
    call _puts                      ;prints answer
    call _runindicoff               ;turn off run indicator
    call _newline
    ret                             ;return to call

CalcOff:
    res  3,(iy+8)                   ;lock the ADP
    set  4,(iy+8)                   ;expire ADP
    call $4101                      ;turns off calculator
    ret                             ;return

Exit:
    call _clrScrn                   ;clears the screen
    call _homeup                    ;moves cursor to upper left
    ret                             ;return that exits the program

#include "Menu86.asm"

Na:                               ;8.93696432671
    .db $00,$00,$FC,$89,$36,$96,$43,$26,$71,$00

STR0:   .db "Stoichiometry-86 v2.4",0
STR1:   .db "#####################"
        .db "#Stoichiometry! v0.9#"
        .db "#    by:Jay Maus    #"
        .db "# and Morgan Davies #"
        .db "#(c)1999  CentraSoft#"
        .db "#cloaker@hotmail.com#"
        .db "#####################",0
STR2:   .db "g>mol    mol>g       M>M           V>V            M>V",0   
STR3:   .db "V>M           Quit",0

A1: .db "Stuff:",0
A2: .db "Mass:",0
A3: .db "Moles:",0
A4: .db "Particles:",0

B1: .db "Moles of ",0
B2: .db "Particle Mass:",0
B3: .db "Grams:",0

C1: .db "Ratio of Target ",0
C2: .db "Target:",0

D1: .db "Gas:",0
D2: .db "Litres:",0

E1: .db "Solid:",0
E2: .db "Molar Ratio of ",0

F1: .db "Particle Mass(Solid)",0
F2: .db "Molar Ratio of ",0

G1: .db "Grams of ",0
G2: .db "Particle ",0
G3: .db "Pmass of ",0
G4: .db "Litres of ",0
G5: .db "Particle Mass of ",0
G6: .db ":",0

.end
END